<!DOCTYPE html>
<html lang="en">
<head>
     <meta charset="UTF-8">
     <meta http-equiv="X-UA-Compatible" content="IE=edge">
     <meta name="viewport" content="width=device-width, initial-scale=1.0">
     <title>Task 41.55 Filter User</title>

     <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome Icons -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">


</head>
<body>
     <div class="hold-transition sidebar-mini">
          <div class="wrapper">
               <!-- Navbar -->
               <nav class="main-header navbar navbar-expand navbar-white navbar-light">
                   <!-- Left navbar links -->
                   <ul class="navbar-nav">
                       <li class="nav-item">
                           <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                       </li>
                       <li class="nav-item d-none d-sm-inline-block">
                           <a href="" class="nav-link">FILTER ORDERS</a>
                       </li>
                   </ul>
                   <!-- Right navbar links -->
                   <ul class="navbar-nav ml-auto">
                       <!-- Notifications Dropdown Menu -->
                       <li class="nav-item">
                           <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                               <i class="fas fa-expand-arrows-alt"></i>
                           </a>
                       </li>
                   </ul>
               </nav>
               <!-- /.navbar -->
               <!-- Main Sidebar Container -->
               <aside class="main-sidebar sidebar-dark-primary elevation-4">
                   <!-- Brand Logo -->
                   <a href="" class="brand-link">
                       <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                           style="opacity: .8">
                       <span class="brand-text font-weight-light">Devcamp</span>
                   </a>
       
                   <!-- Sidebar -->
                   <div class="sidebar">
                       <!-- Sidebar user panel (optional) -->
                       <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                           <div class="image">
                               <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                           </div>
                           <div class="info">
                               <a href="#" class="d-block">Devcamp</a>
                           </div>
                       </div>
       
                       <!-- SidebarSearch Form -->
                       <div class="form-inline">
                           <div class="input-group" data-widget="sidebar-search">
                               <input class="form-control form-control-sidebar" type="search" placeholder="Search"
                                   aria-label="Search">
                               <div class="input-group-append">
                                   <button class="btn btn-sidebar">
                                       <i class="fas fa-search fa-fw"></i>
                                   </button>
                               </div>
                           </div>
                       </div>
       
                       <!-- Sidebar Menu -->
                       <nav class="mt-2">
                           <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                               data-accordion="false">
                               <!-- Add icons to the links using the .nav-icon class
                      with font-awesome or any other icon font library -->
                               <li class="nav-item menu-open">
                                   <a href="#" class="nav-link active">
                                       <i class="nav-icon fas fa-tachometer-alt"></i>
                                       <p>
                                             FILTER ORDERS
                                           <i class="right fas fa-angle-left"></i>
                                       </p>
                                   </a>
                                   <ul class="nav nav-treeview">
                                       <li class="nav-item">
                                           <a href="#" class="nav-link ">
                                               <i class="far fa-circle nav-icon"></i>
                                               <p>Active Page</p>
                                           </a>
                                       </li>
                                       <li class="nav-item">
                                           <a href="#" class="nav-link">
                                               <i class="far fa-circle nav-icon"></i>
                                               <p>Inactive Page</p>
                                           </a>
                                       </li>
                                   </ul>
                               </li>
                               <li class="nav-item">
                                   <a href="#" class="nav-link">
                                       <i class="nav-icon fas fa-th"></i>
                                       <p>
                                           Simple Link
                                           <span class="right badge badge-danger">New</span>
                                       </p>
                                   </a>
                               </li>
                           </ul>
                       </nav>
                       <!-- /.sidebar-menu -->
                   </div>
                   <!-- /.sidebar -->
               </aside>
               <!-- Content Wrapper. Contains page content -->
               <div class="content-wrapper">
                   <!-- Content Header (Page header) -->
                   <div class="content-header">
                       <div class="container-fluid">
                           <div class="row mb-2">
                               <div class="col-sm-6">
                                   <h1 class="m-0">Dashboard V3</h1>
                               </div><!-- /.col -->
                               <div class="col-sm-6">
                                   <ol class="breadcrumb float-sm-right">
                                       <li class="breadcrumb-item"><a href="#">Home</a></li>
                                       <li class="breadcrumb-item active">Starter Page</li>
                                   </ol>
                               </div><!-- /.col -->
                           </div><!-- /.row -->
                       </div><!-- /.container-fluid -->
                   </div>
                   <!-- /.content-header -->
       
                   <!-- Main content -->
                   <div class="content">
                    <div class="container">
                         <h2 style="text-align: center;">Danh sách đơn hàng</h2>
                         <div class="jumbotron container">
                              <div class="form-group row">
                                   <div class="col-md-5 row">
                                        <div class="col-md-6 text-center">
                                             <label class="form-group mx-2">Trạng thái oder</label>
                                        </div>
                                        <div class="col-md-6">
                                             <select class="form-control" id="select-status">
                                                  <option value="all">All</option>
                                                  <option value="open">Open</option>
                                                  <option value="confirmed">Confirmed</option>
                                                  <option value="cancel">Cancel</option>
                                             </select>
                                        </div>
                                   </div>
                                   <div class="col-md-5 row">
                                         <div class="col-md-6 text-center">
                                             <label class="form-group mx-2">Loại Pizza</label>
                                        </div>
                                        <div class="col-md-6">
                                             <select class="form-control" id="select-pizza">
                                                  <option value="all">All</option>
                                                  <option value="hawaii">Hawaii</option>
                                                  <option value="bacon">Bacon</option>
                                                  <option value="seafood">Seafood</option>
                                             </select>
                                        </div>
                                   </div>
                                   <div class="col-md-2 row">
                                        <div class="col-md-12 text-right">
                                             <button class="btn btn-success" id="btn-filter">Lọc</button>
                                        </div>
                                   </div>
                              </div>
                         </div>
                         <table class="table table-bordered table-striped table-hover" id="table-order">
                              <thead>
                                   <tr>
                                        <th>Order Code</th>
                                        <th>Kích cỡ combo</th>
                                        <th>Loại Pizza</th>
                                        <th>Nước uống</th>
                                        <th>Thành Tiền</th>
                                        <th>Họ và tên</th>
                                        <th>Số điện thoại</th>
                                        <th>Trạng thái</th>
                                        <th>Action</th>
                                   </tr>
                              </thead>
                         </table>
                    </div>
                    </div>
       
                       <!-- Vùng Modal -->
       
                       <!-- Create voucher modal -->
                       <div>
                           <div id="create-voucher-modal" class="modal fade" tabindex="-1">
                               <div class="modal-dialog">
                                   <div class="modal-content">
                                       <div class="modal-header">
                                           <h5 class="modal-title" id="h5-modal-title">Create new voucher</h5>
                                           <button class="close" data-dismiss="modal">&times;</button>
                                       </div>
                                       <div class="modal-body">
                                           <form>
                                               <div class="row form-group">
                                                   <div class="col-sm-4">
                                                       <label for="input-create-voucher-code">Voucher code</label>
                                                   </div>
                                                   <div class="col-sm-8">
                                                       <input type="text" id="input-create-voucher-code" name="vouchercodes"
                                                           placeholder="Voucher code" class="form-control">
                                                   </div>
                                               </div>
                                               <div class="row form-group">
                                                   <div class="col-sm-4">
                                                       <label for="input-create-discount">Discount</label>
                                                   </div>
                                                   <div class="col-sm-8">
                                                       <input type="number" id="input-create-discount" name="discount"
                                                           placeholder="Discount" class="form-control">
                                                   </div>
                                               </div>
                                           </form>
                                       </div>
                                       <div class="modal-footer">
                                           <button class="btn btn-secondary" id="btn-create-cancel"
                                               data-dismiss="modal">Cancel</button>
                                           <button class="btn btn-primary" id="btn-create-voucher">Create Voucher</button>
                                       </div>
                                   </div>
                               </div>
                           </div>
                       </div>
       
                       <!-- Update voucher modal -->
                       <div>
                           <div id="update-voucher-modal" class="modal fade" tabindex="-1">
                               <div class="modal-dialog">
                                   <div class="modal-content">
                                       <div class="modal-header">
                                           <h5 class="modal-title" id="h5-modal-title">Update a Voucher</h5>
                                           <button class="close" data-dismiss="modal">&times;</button>
                                       </div>
                                       <div class="modal-body">
                                           <form>
                                               <div class="row form-group">
                                                   <div class="col-sm-4">
                                                       <label for="input-update-voucher-code">Voucher code</label>
                                                   </div>
                                                   <div class="col-sm-8">
                                                       <input type="text" id="input-update-voucher-code" name="vouchercodes"
                                                           placeholder="Voucher code" class="form-control">
                                                   </div>
                                               </div>
                                               <div class="row form-group">
                                                   <div class="col-sm-4">
                                                       <label for="input-update-discount">Discount</label>
                                                   </div>
                                                   <div class="col-sm-8">
                                                       <input type="number" id="input-update-discount" name="discount"
                                                           placeholder="Discount" class="form-control">
                                                   </div>
                                               </div>
                                           </form>
                                       </div>
                                       <div class="modal-footer">
                                           <button class="btn btn-secondary" id="btn-update-cancel"
                                               data-dismiss="modal">Cancel</button>
                                           <button class="btn btn-primary" id="btn-update-voucher">Update Voucher</button>
                                       </div>
                                   </div>
                               </div>
                           </div>
                       </div>
       
                       <!-- Delete confirm modal -->
                       <div>
                           <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                               <div class="modal-dialog">
                                   <div class="modal-content">
                                       <div class="modal-header">
                                           <h5 class="modal-title" id="h5-modal-title">Voucher Delete Confirmation</h5>
                                           <button class="close" data-dismiss="modal">&times;</button>
                                       </div>
                                       <div class="modal-body">
                                           <label>Bạn có chắc chắn muốn xóa voucher này không?</label>
                                       </div>
                                       <div class="modal-footer">
                                           <button class="btn btn-danger" id="btn-confirm-delete-voucher">Confirm</button>
                                           <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                       </div>
                                   </div>
                               </div>
                           </div>
                       </div>
                   </div><!-- /.container-fluid -->
               </div>
               <!-- /.content -->
           </div>
           <!-- /.content-wrapper -->
       
           <!-- Control Sidebar -->
           <aside class="control-sidebar control-sidebar-dark">
               <!-- Control sidebar content goes here -->
               <div class="p-3">
                   <h5>Title</h5>
                   <p>Sidebar content</p>
               </div>
           </aside>
           <!-- /.control-sidebar -->
           <!-- Main Footer -->
           <footer class="main-footer">
               <!-- To the right -->
               <div class="float-right d-none d-sm-inline">
                   Anything you want
               </div>
               <!-- Default to the left -->
               <strong>Copyright &copy; 2023 <a href="https://adminlte.io">Devcamp</a>.</strong> All rights
               reserved.
           </footer>
           </div>
           <!-- ./wrapper -->
           <!-- REQUIRED SCRIPTS -->

     <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
</body>

<script>
     "use strict"
     $(document).ready(function(){
          /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
          var gDataOrders = []; //khai báo mảng (biến toàn cục) để chứa thông tin đơn hàng
          const gORDER = ["orderCode", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
          //khai báo các cột datatable
          const gCOL_ORDER_CODE = 0;
          const gCOL_KICH_CO = 1;
          const gCOL_LOAI_PIZZA = 2;
          const gCOL_ID_LOAI_NUOC_UONG = 3;
          const gCOL_THANH_TIEN = 4;
          const gCOL_HO_TEN = 5;
          const gCOL_SO_DIEN_THOAI = 6;
          const gCOL_TRANG_THAI = 7;
          const gCOL_ACTION = 8;

          //đinh nghĩa table chưa có data
          $("#table-order").DataTable({
               "columns": [
                    {"data": gORDER[gCOL_ORDER_CODE]},
                    {"data": gORDER[gCOL_KICH_CO]},
                    {"data": gORDER[gCOL_LOAI_PIZZA]},
                    {"data": gORDER[gCOL_ID_LOAI_NUOC_UONG]},
                    {"data": gORDER[gCOL_THANH_TIEN]},
                    {"data": gORDER[gCOL_HO_TEN]},
                    {"data": gORDER[gCOL_SO_DIEN_THOAI]},
                    {"data": gORDER[gCOL_TRANG_THAI]},
                    {"data": gORDER[gCOL_ACTION]}
               ],
               //ghi đè nội dung của cột action, chuyển thành  nút chi tiết 
               "columnDefs": [
                    {
                         "targets": gCOL_ACTION,
                         "defaultContent": "<button class = 'btn btn-primary btn-detail'>Chi tiết</button>"
                    }
               ]
          })

          /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
          onPageLoading();

          //gán sự kiện cho nút chi tiết 
          $("#table-order").on("click", ".btn-detail", function(){
               onBtnChiTietClick(this); //this là button được ấn 
          });

          //gán sự kiện click cho nút lọc
          $("#btn-filter").on("click", function(){
               onBtnFilterLocClick(); 
          });
          /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */ 
          //hàm xử lý việc tải trang
          function onPageLoading(){
               //lấy data từ sever
               $.ajax({
                    url: "http://203.171.20.210:8080/devcamp-pizza365/orders",
                    type: "GET", 
                    dataType: "json",
                    success: function(res){
                         gDataOrders = res;
                         console.log(gDataOrders);

                         //gọi hàm loadData đổ dữ liệu vào bảng 
                         loadDataToTable(res);
                    }, 
                    error: function(err){
                         console.assert(err.responseText);
                    }

               });
          }
          /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */

          //hàm load dữ liệu vào bảng 
          function loadDataToTable(paramResObj){
               "use strict";
               var vUserTable = $("#table-order").DataTable();
               //xóa toàn bộ dữ liệu đang có của bảng
               vUserTable.clear();
               //cập nhật dâta cho bảng 
               vUserTable.rows.add(paramResObj);
               // cập nhật lại giao diện hiển thị bảng 
               vUserTable.draw();
          }

          //hàm xử lý khi ấn nút chi tiết 
          function onBtnChiTietClick(paramChiTietBtn){
               "use strict";
               var vUserTable = $("#table-order").DataTable();
               //xác định thẻ tr là cha của nút tùy chọn 
               var vRowSelected = $(paramChiTietBtn).parents("tr");
               //lấy data row
               var vDataTableRow = vUserTable.row(vRowSelected);
               //lấy data của dòng 
               var vUserData = vDataTableRow.data();
               var vId = vUserData.id;
               var vOrderCode = vUserData.orderCode;
               var vKichCo = vUserData.kichCo;
               var vLoaiPizza = vUserData.loaiPizza;
               var vIdLoaiNuocUong = vUserData.idLoaiNuocUong;
               var vThanhTien  = vUserData.thanhTien;
               var vHoTen = vUserData.hoTen;
               var vSoDienThoai = vUserData.soDienThoai;
               var vTrangThai = vUserData.trangThai;

               console.log(vId);
               console.log(vOrderCode);
               console.log(vKichCo);
               console.log(vLoaiPizza);
               console.log(vIdLoaiNuocUong);
               console.log(vThanhTien);
               console.log(vHoTen);
               console.log(vSoDienThoai);
               console.log(vTrangThai);
          }

           //hàm filter(lọc) data
          function onBtnFilterLocClick(){
               "use strict";
               var vStatus = $("#select-status").val();
               var vPizzaType = $("#select-pizza").val();
               // console.log(vStatus);
               // console.log(vPizzaType);
                    var vDataFilter = gDataOrders.filter(function (paramOrder, index){
                         return (vStatus === "all" || (paramOrder.trangThai && vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase()))
                              && (vPizzaType === "all" || (paramOrder.loaiPizza && vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase()))
               });  

               //gọi hàm load đổ dữ liệu vào bảng 
               loadDataToTable(vDataFilter);
          }


     });

</script>
</html>